#include <stdio.h>
#include <dos.h>
#include <string.h>
#include "poly_ex.h"
#include "polymidi.h"
#include "menu.h"
#define YES 1
#define NO 0

static POLYBANK TempBank;
static unsigned char buf[1634];
FILE *FileOut;

int
receive_mem(unsigned char *data)
{
/* grab data from POLY/EX-800 */

   int x, s=0, ret;
   unsigned char d1, d2;

/*   FlushMidi();*/
   MidiXmit(0xf0);				/* send out 'data dump request' */
   MidiXmit(0x42);
   MidiXmit(0x21);
   MidiXmit(0x06);
   MidiXmit(0x10);
   MidiXmit(0xf7);
   MidiRDisable();
   MidiREnable();
/*   delay(500);*/
   for(x=0;x<4;x++)
      d1 = MidiRecv();		/* Strip SysEx part of message	*/

   for(x=0;x<1634;x++)			/* get data in bytes			*/
   {
      d1 = MidiRecv() & 0xff;
      d2 =(MidiRecv() & 0xff)*16;
      data[x]=d1+d2;
   }

   MidiRDisable();
   for(x=0;x<1633;x++)			/* Calculate checksum			*/
      s += data[x];

   if( (s&0xff)==data[1633] )	/* Compare calculated cs against transmitted cs */
   {
      WriteMsg("Data received OK\0");
      ret=1;
   }
   else
   {
      WriteMsg("Data Checksum error - try again!\0");
      ret=0;
   }
return(ret);
}

void
save_mem(unsigned char *data)
{
/* save the data array to disk (current directory) */

   int i=0, save=0,cs,Response;
   char name[80],file[13],msg[80];
   FILE *fptr;

   GetPrompt("Please enter a filename (up to 8 characters): \0",name);
   strncpy(file,name,8);
   file[8]=0;
   strcat(file,".pch\0");
   strcpy(msg,"Saving as \0");
   strcat(msg,file);
   strcat(msg," ... OK? (y/n) \0");
   Response = GetConfirmation(msg);

   if (Response == YES)
   {
      if((fptr=fopen(file,"r"))==NULL)
	 save=1;
      else
      {
	 Response = GetConfirmation("File exists! Overwrite? (y/n)\0");
	 if(Response == YES)
	    save=1;
	 fclose(fptr);
      }
   }

   if(save==1)
   {
      if( (fptr=fopen(file,"wb"))!=NULL)
      {
	 WriteMsg("saving file...\0");
	 cs=fwrite(data,sizeof(unsigned char),1634,fptr);
	 WriteMsg("...saved.\0");
	 fclose(fptr);
	 WriteMsg("Verifying Save...\0");
	 fptr=fopen(file,"rb");
	 for(i=0;i<1634;i++)
	 {
	    if(data[i]!=fgetc(fptr))
	       cs=0;
	 }
	 fclose(fptr);
	 if(cs!=0)
	    WriteMsg("...Data Ok.\0");
	 else
	    WriteMsg("...Data error.\0");
      }
      else
	 WriteMsg("File couldn't be opened...\0");
   }
}

int
load_mem(unsigned char *data)
{
/* load data array from disk (current directory) */

   int cs, ret, Response, NameTerm;
   char name[80],file[13],msg[80];
   FILE *fptr;
   GetPrompt("Please enter a filename (up to 8 characters): ",name);
/*   NameTerm = strspn(name,period);*/
   strncpy(file,name,8);
   file[8]=0;
   strcat(file,".pch");
   strcpy(msg,"Load ");
   strcat(msg,file);
   strcat(msg," ? (y/n)");
   Response = GetConfirmation(msg);
   if (Response==YES)
   {
      if((fptr=fopen(file,"rb"))==NULL)
      {
	 WriteMsg("File doesn't exist!");
	 ret=0;
      }
      else
      {
	 strcpy(msg,"Loading ...");
	 strcat(msg,file);
	 WriteMsg(msg);
	 cs=fread(data,sizeof(unsigned char),1634,fptr);
	 if(cs!=1634)
	 {
	    WriteMsg("...Data Error.");
	    ret=0;
	 }
	 else
	 {
	    WriteMsg("1634 bytes loaded.");
	    ret=1;
	 }
	 fclose(fptr);
      }
   }
   else
      ret=0;
return(ret);
}

void
put_mem(unsigned char *data)
{
   int i;
   FILE *fptr;
   MidiXmit(0xf0);		/* Tell ex that we are about 	*/
   MidiXmit(0x42);		/* to fill its mind...			*/
   MidiXmit(0x21);
   MidiXmit(0x06);
   for(i=0;i<1634;i++)
   {
      MidiXmit((short)(data[i]&0x0f));
      MidiXmit((short)((data[i]&0xf0) >> 4));
   }
   MidiXmit(0xf7);
}


static int CtoBin(int c, int n)
{
  int a[8];
   a[0]=0;
   a[1]=0;
   a[2]=0;
   a[3]=0;
   a[4]=0;
   a[5]=0;
   a[6]=0;
   a[7]=0;
   if (c >= 128)
   {
      a[7]=1;
      c=c-128;
   }
   if (c >=64)
   {
      a[6]=1;
      c=c-64;
   }
   if (c>=32)
   {
      a[5]=1;
      c=c-32;
   }
   if (c>=16)
   {
      a[4]=1;
      c=c-16;
   }
   if (c>=8)
   {
      a[3]=1;
      c=c-8;
   }
   if (c>=4)
   {
      a[2]=1;
      c=c-4;
   }
   if (c>=2)
   {
      a[1]=1;
      c=c-2;
   }
   if (c>=1)
   {
      a[0]=1;
   }
   c=a[n-1];
   return c;
}




int ReadIntro()
{
      TempBank.Intro[0]=1;
      TempBank.Intro[1]=1;
      TempBank.Intro[2]=1;
      TempBank.Intro[3]=1;
      TempBank.Intro[4]=0;
      TempBank.Intro[5]=0;
      TempBank.Intro[6]=0;
      TempBank.Intro[7]=0;
      TempBank.Intro[8]=0;
      TempBank.Intro[9]=1;
      TempBank.Intro[10]=0;
      TempBank.Intro[11]=0;
      TempBank.Intro[12]=0;
      TempBank.Intro[13]=0;
      TempBank.Intro[14]=1;
      TempBank.Intro[15]=0;
      TempBank.Intro[16]=0;
      TempBank.Intro[17]=0;
      TempBank.Intro[18]=1;
      TempBank.Intro[19]=0;
      TempBank.Intro[20]=0;
      TempBank.Intro[21]=0;
      TempBank.Intro[22]=0;
      TempBank.Intro[23]=1;
      TempBank.Intro[24]=0;
      TempBank.Intro[25]=0;
      TempBank.Intro[26]=0;
      TempBank.Intro[27]=0;
      TempBank.Intro[28]=0;
      TempBank.Intro[29]=1;
      TempBank.Intro[30]=1;
      TempBank.Intro[31]=0;
   return 0;
}

int ReadRAM()
{
static   int c,i,j,k;
   c=0;
   i=0;
   j=0;
   k=0;

   c=buf[0];
   {
      TempBank.MIDICh[0]=CtoBin(c,8);
      TempBank.MIDICh[1]=CtoBin(c,7);
      TempBank.MIDICh[2]=CtoBin(c,6);
      TempBank.MIDICh[3]=CtoBin(c,5);
      TempBank.MIDICh[4]=CtoBin(c,4);
      TempBank.MIDICh[5]=CtoBin(c,3);
      TempBank.MIDICh[6]=CtoBin(c,2);
      TempBank.MIDICh[7]=CtoBin(c,1);
   }
   for (i=1;i<=256;i++)
   {
      c=buf[i];
      {
	 TempBank.SEQ[0+((i-1)*8)]=CtoBin(c,8);
	 TempBank.SEQ[1+((i-1)*8)]=CtoBin(c,7);
	 TempBank.SEQ[2+((i-1)*8)]=CtoBin(c,6);
	 TempBank.SEQ[3+((i-1)*8)]=CtoBin(c,5);
	 TempBank.SEQ[4+((i-1)*8)]=CtoBin(c,4);
	 TempBank.SEQ[5+((i-1)*8)]=CtoBin(c,3);
	 TempBank.SEQ[6+((i-1)*8)]=CtoBin(c,2);
	 TempBank.SEQ[7+((i-1)*8)]=CtoBin(c,1);
      }
   }
   for (i=1;i<=8;i++)
   {
      c=buf[257+i];
      TempBank.Chord[0+((i-1)*8)] = CtoBin(c,8);
      TempBank.Chord[1+((i-1)*8)] = CtoBin(c,7);
      TempBank.Chord[2+((i-1)*8)] = CtoBin(c,6);
      TempBank.Chord[3+((i-1)*8)] = CtoBin(c,5);
      TempBank.Chord[4+((i-1)*8)] = CtoBin(c,4);
      TempBank.Chord[5+((i-1)*8)] = CtoBin(c,3);
      TempBank.Chord[6+((i-1)*8)] = CtoBin(c,2);
      TempBank.Chord[7+((i-1)*8)] = CtoBin(c,1);
   }
   c=buf[288];
   for (j=0;j<=63;j++)
   {
      for (i=1;i<=21;i++)
      {
	 c=buf[287+i+(21*j)];
	 {
	    TempBank.Prog[j][7+((i-1)*8)]=CtoBin(c,8);
	    TempBank.Prog[j][6+((i-1)*8)]=CtoBin(c,7);
	    TempBank.Prog[j][5+((i-1)*8)]=CtoBin(c,6);
	    TempBank.Prog[j][4+((i-1)*8)]=CtoBin(c,5);
	    TempBank.Prog[j][3+((i-1)*8)]=CtoBin(c,4);
	    TempBank.Prog[j][2+((i-1)*8)]=CtoBin(c,3);
	    TempBank.Prog[j][1+((i-1)*8)]=CtoBin(c,2);
	    TempBank.Prog[j][0+((i-1)*8)]=CtoBin(c,1);
	 }
      }
   }
   for (j=0;j<=63;j++)
   {
      i = TempBank.Prog[j][41];
      TempBank.Prog[j][41] = TempBank.Prog[j][39];
      TempBank.Prog[j][39] = TempBank.Prog[j][37];
      TempBank.Prog[j][37] = TempBank.Prog[j][40];
      TempBank.Prog[j][40] = TempBank.Prog[j][38];
      TempBank.Prog[j][38] = i;
   }
   return 0;
}

int ReadChkSum()
{
  int c;
  c = buf[1633];
  TempBank.ChkSum[0] = CtoBin(c,8);
  TempBank.ChkSum[1] = CtoBin(c,7);
  TempBank.ChkSum[2] = CtoBin(c,6);
  TempBank.ChkSum[3] = CtoBin(c,5);
  TempBank.ChkSum[4] = CtoBin(c,4);
  TempBank.ChkSum[5] = CtoBin(c,3);
  TempBank.ChkSum[6] = CtoBin(c,2);
  TempBank.ChkSum[7] = CtoBin(c,1);
  return 0;
}

int ReadEOX()
{
   TempBank.EOX[0] = 1;
   TempBank.EOX[1] = 1;
   TempBank.EOX[2] = 1;
   TempBank.EOX[3] = 1;
   TempBank.EOX[4] = 0;
   TempBank.EOX[5] = 1;
   TempBank.EOX[6] = 1;
   TempBank.EOX[7] = 1;
   return 0;
}


int PrintHeader(FILE *FileOut)
{
   fprintf(FileOut,"%s\n","                                                                             C");
   fprintf(FileOut,"%s\n","                                                        N                    H");
   fprintf(FileOut,"%s\n","                          M                             O                    O");
   fprintf(FileOut,"%s\n","                          O                             I                    R");
   fprintf(FileOut,"%s\n","PROG                      D                             S                    U");
   fprintf(FileOut,"%s\n"," No          DCO 1        E           DCO 2             E        VCF         S           DEG 1             DEG 2            DEG 3         MG");
   fprintf(FileOut,"%s\n"," ");
   fprintf(FileOut,"%s\n","                                                              R  K");
   fprintf(FileOut,"%s\n","        W                       W                 I           E  B  P");
   fprintf(FileOut,"%s\n","        A                       A                 N           S  D  O     T           B     S  R        B     S  R        B     S  R");
   fprintf(FileOut,"%s\n","     O  V                    O  V                 T  D     C  O     L  E  R  O  A     R     U  E  A     R     U  E  A     R     U  E");
   fprintf(FileOut,"%s\n","     C  E              L     C  E              L  E  E  L  U  N  T  A  G  I  N  T  D  E  S  S  L  T  D  E  S  S  L  T  D  E  S  S  L     D");
   fprintf(FileOut,"%s\n","     T  F              E     T  F              E  R  T  E  T  A  R  R     G  /  T  E  A  L  T  E  T  E  A  L  T  E  T  E  A  L  T  E  F  E");
   fprintf(FileOut,"%s\n","     A  O  1           V  D  A  O  1           V  V  U  V  O  N  A  I  I  G  O  A  C  K  O  A  A  A  L  K  O  A  A  A  L  K  O  A  A  R  L  D  V");
   fprintf(FileOut,"%s\n","     V  R  6  8  4  2  E  C  V  R  6  8  4  2  E  A  N  E  F  C  C  T  N  E  F  C  A     P  I  S  C  A     P  I  S  C  A     P  I  S  E  A  C  C");
   fprintf(FileOut,"%s\n","     E  M  '  '  '  '  L  O  E  M  '  '  '  '  L  L  E  L  F  E  K  Y  T  R  F  K  Y  P  E  N  E  K  Y  P  E  N  E  K  Y  P  E  N  E  Q  Y  O  F");
   fprintf(FileOut,"%s\n"," ");
   fprintf(FileOut,"%s\n","     1  1  1  1  1  1  1  1  2  2  2  2  2  2  2  3  3  3  4  4  4  4  4  4  4  5  5  5  5  5  5  6  6  6  6  6  6  7  7  7  7  7  7  8  8  8  8");
   fprintf(FileOut,"%s\n","     1  2  3  4  5  6  7  8  1  2  3  4  5  6  7  1  2  3  1  2  3  4  5  6  8  1  2  3  4  5  6  1  2  3  4  5  6  1  2  3  4  5  6  1  2  3  4");
   fprintf(FileOut,"%s\n"," ");
   return 0;
}

int PrintIntro(FILE *FileOut)
{
   fprintf(FileOut,"%s%d%d%d%d%d%d%d%d\n","Korg ID Status : ",TempBank.Intro[0],TempBank.Intro[1],TempBank.Intro[2],TempBank.Intro[3],TempBank.Intro[4],TempBank.Intro[5],TempBank.Intro[6],TempBank.Intro[7]);
   fprintf(FileOut,"%s%d%d%d%d%d%d%d%d\n","Korg ID Data   : ",TempBank.Intro[8],TempBank.Intro[9],TempBank.Intro[10],TempBank.Intro[11],TempBank.Intro[12],TempBank.Intro[13],TempBank.Intro[14],TempBank.Intro[15]);
   fprintf(FileOut,"%s%d%d%d%d%d%d%d%d\n","Format ID Data : ",TempBank.Intro[16],TempBank.Intro[17],TempBank.Intro[18],TempBank.Intro[19],TempBank.Intro[20],TempBank.Intro[21],TempBank.Intro[22],TempBank.Intro[23]);
   fprintf(FileOut,"%s%d%d%d%d%d%d%d%d\n","MDK ID Status  : ",TempBank.Intro[24],TempBank.Intro[25],TempBank.Intro[26],TempBank.Intro[27],TempBank.Intro[28],TempBank.Intro[29],TempBank.Intro[30],TempBank.Intro[31]);
   return 0;
}

int PrintMIDI(FILE *FileOut)
{
   fprintf(FileOut,"%s%d%d%d%d%d%d%d%d\n","MIDI Ch. Info  : ",TempBank.MIDICh[0],TempBank.MIDICh[1],TempBank.MIDICh[2],TempBank.MIDICh[3],TempBank.MIDICh[4],TempBank.MIDICh[5],TempBank.MIDICh[6],TempBank.MIDICh[7]);
   fprintf(FileOut,"%s","Take Number From Above, add 1 & get your MIDI RCV Ch.");
   return 0;
}

int PrintSEQ(FILE *FileOut)
{
   static int i;
   i=0;
   fprintf(FileOut,"%s\n","Sequencer Data - 256 Bytes");
   for (i=1;i<=256;i++)
   {
      fprintf(FileOut,"%d%s",i,"Byte  ");
      fprintf(FileOut,"%d%d%d%d",TempBank.SEQ[0+((i-1)*8)],TempBank.SEQ[1+((i-1)*8)],TempBank.SEQ[2+((i-1)*8)],TempBank.SEQ[3+((i-1)*8)]);
      fprintf(FileOut,"%d%d%d%d\n",TempBank.SEQ[4+((i-1)*8)],TempBank.SEQ[5+((i-1)*8)],TempBank.SEQ[6+((i-1)*8)],TempBank.SEQ[7+((i-1)*8)]);
   }
   return 0;
}

int PrintChord(FILE *FileOut)
{
   fprintf(FileOut,"Chord Data : %d%d%d%d%d%d%d%d\n",TempBank.Chord[0],TempBank.Chord[1],TempBank.Chord[2],TempBank.Chord[3],TempBank.Chord[4],TempBank.Chord[5],TempBank.Chord[6],TempBank.Chord[7]);
   return 0;
}

int power2(int exponent)
{
   int i, value;

   value = 1;
   for (i = 1; i <= exponent; i++)
      value = value * 2;
   return value;
}

int BinToInt(int start, int stop, int index)
{
   int i, j, value;

   value = 0;
   j = 0;
   for (i = stop; i <= start; i++)
   {
      value = value + TempBank.Prog[index][i] * power2(j);
      j = j + 1;
   }
   return value;
}

int Flip(int val)
{
   if (val == 1)
      return 0;
   else
      return 1;
}


int PrintPrograms(FILE *FileOut)
{

   int ProgNumber[64] = {11,12,13,14,15,16,17,18,21,22,23,24,25,26,27,28
			   ,31,32,33,34,35,36,37,38,41,42,43,44,45,46,47,48,
			   51,52,53,54,55,56,57,58,61,62,63,64,65,66,67,68,
			   71,72,73,74,75,76,77,78,81,82,83,84,85,86,87,88};
   int i,j;
   fprintf(FileOut,"%s\n","At PrintPrograms");
  for (j = 0; j <= 63; j++)
  {

    fprintf(FileOut," %2d",ProgNumber[j]);

    fprintf(FileOut,"  %d",BinToInt(1,0,j) + 1);   /* DCO 1 Octave */
    fprintf(FileOut,"  %d",BinToInt(5,4,j) + 1);   /* DCO 1 Waveform */
    fprintf(FileOut,"  %d",TempBank.Prog[j][8]);   /* DCO 1 16' */
    fprintf(FileOut,"  %d",TempBank.Prog[j][9]);   /* DCO 1 8' */
    fprintf(FileOut,"  %d",TempBank.Prog[j][10]);   /* DCO 1 4' */
    fprintf(FileOut,"  %d",TempBank.Prog[j][11]);   /* DCO 1 2' */
    fprintf(FileOut," %2d",BinToInt(41,37,j));   /* DCO 1 Level */
    fprintf(FileOut,"  %d",TempBank.Prog[j][22] + 1);   /* MODE */
    if (TempBank.Prog[j][22] == 1)
    {
       fprintf(FileOut,"  %d",BinToInt(3,2,j) + 1);   /* DCO 2 Octave */
       fprintf(FileOut,"  %d",BinToInt(7,6,j) + 1);   /* DCO 2 Waveform */
       fprintf(FileOut,"  %d",TempBank.Prog[j][12]);   /* DCO 2 16' */
       fprintf(FileOut,"  %d",TempBank.Prog[j][13]);   /* DCO 2 8' */
       fprintf(FileOut,"  %d",TempBank.Prog[j][14]);   /* DCO 2 4' */
       fprintf(FileOut,"  %d",TempBank.Prog[j][15]);   /* DCO 2 2' */
       fprintf(FileOut," %2d",BinToInt(46,42,j));   /* DCO 2 Level */
       fprintf(FileOut," %2d",BinToInt(27,24,j));   /* DCO 2 Interval */
       fprintf(FileOut,"  %d",BinToInt(17,16,j));   /* DCO 2 Detune */
    }
    else
    fprintf(FileOut,"                           ");
    fprintf(FileOut," %2d",BinToInt(31,28,j));   /* Noise Level */
    fprintf(FileOut," %2d",BinToInt(54,48,j));   /* VCF Cutoff */
    fprintf(FileOut," %2d",BinToInt(165,162,j));   /* VCF Resonance */
    fprintf(FileOut,"  %d",BinToInt(167,166,j));   /* VCF KBD Track */
    fprintf(FileOut,"  %d",TempBank.Prog[j][36] + 1);   /* VCF Polarity */
    fprintf(FileOut," %2d",BinToInt(35,32,j));   /* VCF EG INT */
    fprintf(FileOut,"  %d",TempBank.Prog[j][55] + 1);   /* VCF Trigger */
    fprintf(FileOut,"  %d",Flip(TempBank.Prog[j][23]));   /* Chorus */
    fprintf(FileOut," %2d",BinToInt(76,72,j));   /* DEG 1 Attack */
    fprintf(FileOut," %2d",BinToInt(81,77,j));   /* DEG 1 Decay */
    fprintf(FileOut," %2d",BinToInt(86,82,j));   /* DEG 1 Break Pt */
    fprintf(FileOut," %2d",BinToInt(91,87,j));   /* DEG 1 Slope */
    fprintf(FileOut," %2d",BinToInt(96,92,j));   /* DEG 1 Sustain */
    fprintf(FileOut," %2d",BinToInt(101,97,j));   /* DEG 1 Release */
    if (TempBank.Prog[j][22] == 1)
    {
      fprintf(FileOut," %2d",BinToInt(106,102,j));   /* DEG 2 Attack */
      fprintf(FileOut," %2d",BinToInt(111,107,j));   /* DEG 2 Decay */
      fprintf(FileOut," %2d",BinToInt(116,112,j));   /* DEG 2 Break Pt */
      fprintf(FileOut," %2d",BinToInt(121,117,j));   /* DEG 2 Slope */
      fprintf(FileOut," %2d",BinToInt(126,122,j));   /* DEG 2 Sustain */
      fprintf(FileOut," %2d",BinToInt(131,127,j));   /* DEG 2 Release */
    }
    else
      fprintf(FileOut,"                  ");
    fprintf(FileOut," %2d",BinToInt(136,132,j));   /* DEG 3 Attack */
    fprintf(FileOut," %2d",BinToInt(141,137,j));   /* DEG 3 Decay */
    fprintf(FileOut," %2d",BinToInt(146,142,j));   /* DEG 3 Break Pt */
    fprintf(FileOut," %2d",BinToInt(151,147,j));   /* DEG 3 Slope */
    fprintf(FileOut," %2d",BinToInt(156,152,j));   /* DEG 3 Sustain */
    fprintf(FileOut," %2d",BinToInt(161,157,j));   /* DEG 3 Release */
    fprintf(FileOut," %2d",BinToInt(59,56,j));   /* MG Freq */
    fprintf(FileOut," %2d",BinToInt(63,60,j));   /* MG Delay */
    fprintf(FileOut," %2d",BinToInt(67,64,j));   /* MG DCO */
    fprintf(FileOut," %2d\n",BinToInt(71,68,j));   /* MG VCF */
   }
   return 0;
}

int PrintChkSum(FILE *FileOut)
{
   fprintf(FileOut,"CheckSUM : %d%d%d%d%d%d%d%d\n",TempBank.ChkSum[0],TempBank.ChkSum[1],TempBank.ChkSum[2],TempBank.ChkSum[3],TempBank.ChkSum[4],TempBank.ChkSum[5],TempBank.ChkSum[6],TempBank.ChkSum[7]);
   return 0;
}

int PrintEOX(FILE *FileOut)
{
   fprintf(FileOut,"EOX Designator : %d%d%d%d%d%d%d%d\n",TempBank.EOX[0],TempBank.EOX[1],TempBank.EOX[2],TempBank.EOX[3],TempBank.EOX[4],TempBank.EOX[5],TempBank.EOX[6],TempBank.EOX[7]);
   return 0;
}

int Print_Bank(POLYBANK temp)
{
   int save=0,cs,Response;
   char name[80],file[13],msg[80];
   FILE *fptr;

   GetPrompt("Please enter a filename (up to 8 characters): \0",name);
   strncpy(file,name,8);
   file[8]=0;
   strcat(file,".out\0");
   strcpy(msg,"Saving as \0");
   strcat(msg,file);
   strcat(msg," ... OK? (y/n) \0");
   Response = GetConfirmation(msg);

   if (Response == YES)
   {
      if((fptr=fopen(file,"r"))==NULL)
	 save=1;
      else
      {
	 Response = GetConfirmation("File exists! Overwrite? (y/n)\0");
	 if(Response == YES)
	    save=1;
	 fclose(fptr);
      }
   }

   if(save==1)
   {
      if( (fptr=fopen(file,"w"))!=NULL)
      {
	 WriteMsg("saving file...\0");
/*	 FileOut = fopen("korg.out","w");*/
	 PrintIntro(fptr);
	 PrintMIDI(fptr);
	 PrintSEQ(fptr);
	 PrintChord(fptr);
	 PrintHeader(fptr);
	 PrintPrograms(fptr);
	 PrintChkSum(fptr);
	 PrintEOX(fptr);
/*	 cs=fwrite(data,sizeof(unsigned char),1634,fptr);*/
	 WriteMsg("...saved.\0");
	 fclose(fptr);
/*	 fptr=fopen(file,"rb");
	 for(i=0;i<1634;i++)
	 {
	    if(data[i]!=fgetc(fptr))
	       cs=0;
	 }
	 fclose(fptr);
	 if(cs!=0)
	    WriteMsg("...Data Ok.\0");
	 else
	    WriteMsg("...Data error.\0");*/
      }
      else
	 WriteMsg("File couldn't be opened...\0");
   }
   return 1;
}

void ConvertFromBuf()
{
   ReadIntro();
   ReadRAM();
   ReadChkSum();
   ReadEOX();
}

void ConvertToBuf()
{
   unsigned char RetBuf[1634];

}

POLYBANK Load_Bank(int Status)
{
   POLYBANK Temp;

   if (Status == 0)
   {
   /*  Buffer Not Empty */
   }
   else
      Status = load_mem(buf);
   ConvertFromBuf();
   return(TempBank);
}

int Save_Bank(POLYBANK CurrentBank)
{
   int Status;
   TempBank = CurrentBank;
   ConvertToBuf();
   save_mem(buf);
   return(Status);
}

POLYBANK Receive_Bank(int Status)
{
   POLYBANK Temp;
   Status = receive_mem(buf);
   ConvertFromBuf();
   return(TempBank);
}

int Send_Bank(POLYBANK CurrentBank)
{
   int Status;
   TempBank = CurrentBank;
   ConvertToBuf();
   put_mem(buf);
   return(Status);
}

